Occasionally, you may need to inspect a running Chalk environment to review metadata about your configured Chalk pipelines. You can use the provided REST API to query for this metadata as part of your admin dashboards, monitoring tooling, or team knowledge management.

Note: if you use a user-scoped token (i.e. one that’s derived from chalk login), you will need to specify the environment in which to trigger your resolver via the X-Chalk-Env-Id header.


​
View an environment’s live feature and resolver graph

GET
https://api.chalk.ai/v1/environment/graph
Headers
Authorizationstring

The auth token that should be used for the request, such as Authorization: Bearer $(chalk token)

X-Chalk-Env-Idstring?

The environment ID for which this request should be executed, if the provided Authorization token was not created with an implicit environment

​
Response

Pipelines object

​
Example

curl -XGET -H "Authorization: Bearer $(chalk token)" \
     -H "X-Chalk-Env-Id: <your-environment-id>" \
     https://api.chalk.ai/v1/environment/graph

# Returns

{
  "deployment_id": "<deployment-id>",
  "features": […],
  "resolvers": […]
}

​
View a deployment’s feature and resolver graph

GET
https://api.chalk.ai/v1/deployments/{deployment_id}/graph
Path Params
deployment_idstring

The machine-generated ID for your deployment, usually a 25-character string that begins with c and looks something like cl789789aoa002chalkexample. The deployment can be associated with a preview or production environment.

Headers
Authorizationstring

The auth token that should be used for the request, such as Authorization: Bearer $(chalk token)

X-Chalk-Env-Idstring?

The environment ID for which this request should be executed, if the provided Authorization token was not created with an implicit environment

​
Response

Pipelines object

​
Example

curl -XGET -H "Authorization: Bearer $(chalk token)" \
     -H "X-Chalk-Env-Id: <your-environment-id>" \
     https://api.chalk.ai/v1/deployments/<your-deployment-id>/graph

# Returns
{
  "deployment_id": "<deployment-id>",
  "features": […],
  "resolvers": […]
}

​
Pipelines

Response (JSON)
deployment_idstring

The deployment ID that is being described by this graph

featuresFeatureInfo[]

Array of FeatureInfo objects, one for each Feature in your deployment. Most of the metadata in each FeatureInfo is defined in your Feature() declaration

FeatureInfo
fqnstring

The fully-qualified name of this feature, like user.id

namestring

The name of this feature, like “User first name”

detailobject

Additional metadata about this feature’s value type, including its underlying raw type, whether it’s a primary key, and feature version metadata.

tagsstring[]

The user tags associated with this feature

created_atstring

An ISO-8601 datetime string describing when this feature was first introduced to your deployment

updated_atstring

An ISO-8601 datetime string describing when this feature was last modified by a deployment

etl_offline_to_onlineboolean

Whether this feature has Offline-to-Online Chalk ETL integration

resolversResolverInfo[]

Array of ResolverInfo objects, one for each Resolver in your deployment.

ResolverInfo
fqnstring

The fully-qualified name of this resolver, like example.resolvers.get_user

execution_kind"online" | "offline" | "stream" | "sink"

Whether this resolver is configured to run as an

online or offline resolver, or a stream or sink resolver

tagsstring[]

The user tags associated with this resolver

feature_inputsstring[]

The declared feature input FQNs to this resolver, as a string array

feature_outputsstring[]

The declared feature output FQNs of this resolver, as a string array

cronstring | null

If the resolver is configured to run with a schedule, this field will describe that schedule

updated_atstring

The last time this resolver was modified by a deployment, including its declaration or its implementation, as an ISO-8601 datetime string